# -*- coding: utf-8 -*-
import os
import sys
servidor="https://download.sigsolucoes.net.br/public/.inst/07"
IP_da_Instancia="129.148.55.62"

try:
  fs = open('/tmp/inst.cfg', 'r')
  for linha in fs.readlines():
     if linha.startswith('servidor='):
        servidor = linha[9:].replace('\n', '')
     if linha.startswith('IP_da_Instancia='):
        IP_da_Instancia = linha[16:].replace('\n', '')
  fs.close()
except:
  pass

helpTexto="""
Use: oracle_odoo07_atualizar.py [ argumentos ] 
onde: 
  -h Este help 
  -o Instalar odoo07 
  -u Instalar SigUtils 
  -n Instalar pynfe 
  -s Instalar sped 
  -a Instalar addns 
  -t Instalar tudo 
"""

global dictArqNome

def getNomeArquivoBaixar():
   arquivo = "/tmp/readme.txt"
   os.system('rm -rf %s' % arquivo)
   comando = 'wget %s/readme.txt -O /tmp/readme.txt' % servidor
   os.system(comando)
   fs = open(arquivo, 'r')
   linhas = fs.readlines()
   fs.close()
   res = {}
   for linha in linhas:
     if linha.startswith('geraldo='):
        res.update({'aGeraldo' :linha[8:].replace('\n', '')})
     if linha.startswith('sigutils='):
        res.update({'aSigutils': linha[9:].replace('\n', '')})
     if linha.startswith('nfe='):
        res.update({'aNfe': linha[4:].replace('\n', '')})
     if linha.startswith('sped='):
        res.update({'aSped': linha[5:].replace('\n', '')})
     if linha.startswith('odoo='):
        res.update({'aOdoo': linha[5:].replace('\n', '')})
     if linha.startswith('addons='):
        res.update({'aAddons': linha[7:].replace('\n', '')})
   global dictArqNome
   dictArqNome = res
   return

def _get_comando_wget(arq):
   global dictArqNome
   lista = dictArqNome.get(arq, '').split('/')
   server_name = dictArqNome.get(arq, '')
   arq_name = lista[-1]
   comando = 'wget %s -O /tmp/%s' % (server_name, arq_name)
   os.system('rm -rf /tmp/%s' % arq_name)
   return comando, arq_name, server_name

def _baixar_e_instalar(arq):
   if arq == 'aAddons':
      os.chdir('/sig/addons/7.0')
   else:
      os.chdir('/tmp')
   getNomeArquivoBaixar()
   comando, arq_name, _ = _get_comando_wget(arq)
   os.system(comando)
   os.system('rm -rf /tmp/lista.baixa.txt')
   if arq == 'aAddons':
      _tar = 'tar xfv /tmp/%s -C /sig/addons/7.0 >>/tmp/lista.baixa.txt' % arq_name
   else:
      _tar = 'tar xfv /tmp/%s -C /tmp >>/tmp/lista.baixa.txt' % arq_name
   os.system(_tar)
   os.system('rm -rf /tmp/%s' % arq_name)
   if arq != 'aAddons':
      fs = open('/tmp/lista.baixa.txt', 'r')
      linha = fs.readline().split('/')[0] # só preciso da primeira linha
      fs.close()
      os.chdir('/tmp/%s' % linha)
   os.system('python -mpip install -r requirements.txt')
   if arq != 'aAddons':
      os.system('python setup.py install')
      os.chdir('/tmp')
      os.system('rm -rf /tmp/%s' % linha)

def instalarOdoo():
   print('---> Atualizando o odoo!')
   global dictArqNome
   os.system('sudo wget https://raw.githubusercontent.com/paulfitz/mysql-connector-c/master/include/my_config.h -P /usr/include/mysql/')
   os.system('pip  install https://fossies.org/linux/privat/old/PyChart-1.39.tar.gz')
   os.system('pip  install importlib_metadata==2.1.3')
   os.system('pip  install egenix-mx-base==3.2.9')

   # os.system('pip  install babel==1.3')
   os.system('pip  install babel==2.4.0')
   os.system('pip  install cryptography==2.1.4')
   # os.system('pip  install docutils==0.14')
   os.system('pip  install docutils==0.12')
   # os.system('pip  install feedparser==5.1.3')
   os.system('pip  install feedparser==5.2.1')
   os.system('pip  install gdata==2.0.18')
   os.system('pip  install Jinja2==2.7.3')
   # os.system('pip  install lxml==4.8.0')
   os.system('pip  install lxml==4.2.1')
   os.system('pip  install mako==1.0.0')
   os.system('pip  install mock==1.0.1')
   os.system('pip  install psutil==2.1.1')
   # os.system('pip  install psycopg2==2.7.3.1')  # Para postgres antigo
   os.system('pip  install psycopg2==2.8.4')  #  Para postgres novo
   os.system('pip  install pydot==1.0.2')
   os.system('pip  install python-dateutil==1.5')
   os.system('pip  install python-ldap==2.4.15')
   os.system('pip  install python-openid==2.2.5')
   os.system('pip  install pytz==2014.4')
   os.system('pip  install pywebdav==0.9.8')
   os.system('pip  install pyyaml==3.10')
   os.system('pip  install reportlab==3.1.44')
   os.system('pip  install simplejson==3.5.3')
   os.system('pip  install unittest2==0.5.1')
   os.system('pip  install vatnumber==1.2')
   os.system('pip  install vobject==0.6.6')
   os.system('pip  install werkzeug==0.9.6')
   os.system('pip  install xlwt==0.7.5')
   os.system('pip  install pyopenssl==17.5.0')
   os.system('pip  install pillow==2.5.1')
   os.system('pip  install pycups==1.9.73')
   # os.system('pip  install xmlsec==0.3.1')
   os.system('pip  install pathlib')
   os.system('pip  install dnspython==1.16.0')
   os.system('pip  install gdata==2.0.18')
   os.system('pip  install wheel==0.30.0')
   os.system('pip  install M2Crypto==0.27.0')
   os.system('pip  install numpy==1.16.6')
   os.system('pip  install pyjwt==1.5.3')
   os.system('pip  install BeautifulSoup==3.2.1')
   os.system('pip  install python-stdnum==1.17')
   os.system('pip  install traceback2==1.4.0')
   os.system('pip  install pyparsing==2.1.4')
   os.system('pip  install mysql-python==1.2.5')
   os.system('pip  install requests==2.27.1')
   os.system('pip  install xlrd==1.2.0')
   os.system('pip  install qrcode==5.0.1')
   os.system('pip  install zeep==3.4.0')
   os.system('pip  install html==1.1')
   os.system('pip  install signxml==2.8.1')
   os.system('pip install pandas==0.24.2') # calcmadeira
   os.system('pip install sqlalchemy==1.4.46') # calcmadeira

   print('---> - Baixando, descompactando e instalando odoo')
   _baixar_e_instalar('aGeraldo')
   _baixar_e_instalar('aOdoo')

   # para python 3.8.10 alterar o requirements.txt trocando a versao do gevent para 20.12.0
   print("---> Configurando Serviço odoo")
   os.system('sudo cp /sig/scripts/oracle.odoo07.service /lib/systemd/system/odoo07.service')
   os.system('sudo systemctl enable odoo07.service')

def instalarSigUtils():
   print( "---> Instalando SigUtils")
   global dictArqNome
   _baixar_e_instalar('aSigutils')

def instalarNfe():
   print('echo "---> Instalando Nfe"')
   global dictArqNome
   _baixar_e_instalar('aNfe')

def instalarSped():
   print("---> Instalando Sped")
   global dictArqNome
   _baixar_e_instalar('aSped')

def instalarAddons():
   print("---> Instalando Addons")
   global dictArqNome
   _baixar_e_instalar('aAddons')

if len(sys.argv) != 2:
   print(helpTexto)
elif sys.argv[1] == '-h':
   print(helpTexto)
elif sys.argv[1] == '-o':
   instalarOdoo()
elif sys.argv[1] == '-u':
   instalarSigUtils()
elif sys.argv[1] == '-n':
   instalarNfe()
elif sys.argv[1] == '-s':
   instalarSped()
elif sys.argv[1] == '-a':
   instalarAddons()
elif sys.argv[1] == '-t':
   instalarOdoo()
   instalarSigUtils()
   instalarNfe()
   instalarSped()
   instalarAddons()
else:
   print(helpTexto)
